#include <limits.h>

/*@
  ensures \result >= m && \result >= n;
  ensures \result == m || \result == n;
  assigns \nothing;
 */
int max(int m, int n) {
  if (m <= n) return n;
  else return m;
}

/*@
  requires m <= INT_MAX / 2;
  ensures \result ==  m * 2;
  assigns \nothing;
 */
int dbl(int m) {
  return m * 2;
}

/*@
  assigns \nothing;
 */
int f(void) {
  int m = 3, n = 5;
  int a = max(m, n);
  int b = dbl(m);
  /*@ assert b <= 10; */
  return a + b;
}

/*@
  assigns \nothing;
 */
int main(void) {
  f();
  return 0;
}
