#include <stdint.h>


/*
   requires 0 <= x;
   requires y <= z;
   ensures x * y <= x * z;
   assigns \nothing;
  */
void foo(int x, int y, int z) {
  if (x == 0) return;
  else foo(x - 1, y, z);
}

/*@
  @ requires 0 <= y <= z;
  @ ensures \result * y <= \result * z;
  @ assigns \nothing;
  @*/
int bar(int y, int z) {
  return (y + z) / 2;
}

int main(void) {
  return 0;
}
