#include <limits.h>

/*@
  @ requires 0 <= x <= INT_MAX / 2;
  @ assigns \nothing;
  @ ensures \result == 2 * x;
  @*/
int times2 (int x) {
  int r = 0 ;
  //@ ghost int x0 = x;
  /*@
    @ loop invariant 0 <= x;
    @ loop invariant r == 2 * (x0 - x);
    @ loop assigns r, x;
    @ loop variant x;
    @*/
  while (x > 0) {
    r += 2;
    x --;
  }
  return r;
}

int main(void) {
  return 0;
}
