
/*@
  @ axiomatic Nist {
  @   logic integer nist(integer n);
  @   axiom nist1 : \forall integer n; n < 2 ==> nist(n) == n;
  @   axiom nist2 : \forall integer n; !(n < 2) ==> nist(n) == nist(n - 2) + 2 * nist(n - 1);
  @ }
  @*/

/*@ ghost
 /@
  @ requires 0 <= n;
  @ ensures n <= nist(n);
  @ assigns \nothing;
  @/
void nist_geN(int n) {
  if (n >= 2) {
    nist_geN(n-1);
    nist_geN(n-2);
  }
  return;
}
@*/

/*@ requires 0 <= n < m;
  @ ensures n < nist(m);
  @ assigns \nothing;
  @*/
void foo(int n, int m) {
  //@ ghost nist_geN(m);
}

int main(void) {
  foo(100, 102);
  return 0;
}
