
/*@ requires \valid(a) && \valid(b);
  @ ensures *a == \old(*b) && *b == \old(*a);
  @ assigns *a, *b;
  @*/
void swap(int *a, int *b)
{
  int tmp = *a;
  *a = *b;
  *b = tmp;
}

void order3(int *a, int *b, int *c) {
  if (*a > *b) swap(a, b);
  if (*a > *c) swap(a, c);
  if (*b > *c) swap(b, c);
}
